##############################################################################
#
# Copyright (c) 2003 Zope Corporation and Contributors. All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

"""Quick soap fix test script. Note that this is not a unit test,
   as it is difficult to write a unit test that really exercises
   the real request / publishing machinery for various"""

import httplib


soap_msg = '''<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
 SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
 xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
 xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<SOAP-ENV:Header>
  <t:Transaction xmlns:t="urn:some-uri" SOAP-ENV:mustUnderstand="1">
  5
  </t:Transaction>
  <p:OptionalHeader1 xmlns:p="urn:some-uri" SOAP-ENV:mustUnderstand="0">
  optional data 1
  </p:OptionalHeader1>
  <p:OptionalHeader2 xmlns:p="urn:some-uri">
  optional data 2
  </p:OptionalHeader2>
</SOAP-ENV:Header>
<SOAP-ENV:Body>
  <m:GetLastTradePriceResponse xmlns:m="Some-URI">
    <PriceAndVolume>
      <LastTradePrice>
      34.5
      </LastTradePrice>
      <DayVolume>
      10000
      </DayVolume>
    </PriceAndVolume>
  </m:GetLastTradePriceResponse>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'''

rpc_msg = '''<?xml version="1.0"?>
<methodCall>
<methodName>test.testrpc</methodName>
<params>
<param>
<value><i4>41</i4></value>
</param>
</params>
</methodCall>'''


def test_soap():
    h = httplib.HTTPConnection('localhost', 9080)
    headers = {'Content-Type':'text/xml'}
    h.request('POST', '/test/testxml', soap_msg, headers)
    r = h.getresponse()
    print r.read()

def test_xmlrpc():
    h = httplib.HTTPConnection('localhost', 9080)
    headers = {'Content-Type':'text/xml'}
    h.request('POST', '/test/testrpc', rpc_msg, headers)
    r = h.getresponse()
    print r.read()
